--- /dev/null	Fri Dec 21 15:00:57 2018
+++ new/usr/src/tools/smatch/src/validation/optim/muldiv-minus-one.c	Fri Dec 21 15:00:57 2018
@@ -0,0 +1,18 @@
+typedef	unsigned int u32;
+
+int smulm1(int a) { return a * -1; }
+u32 umulm1(u32 a) { return a * (u32) -1; }
+int sdivm1(int a) { return a / -1; }
+u32 udivm1(u32 a) { return a / (u32) -1; }
+
+/*
+ * check-name: muldiv-minus-one
+ * check-command: test-linearize -Wno-decl $file
+ * check-output-ignore
+ *
+ * check-output-excludes: mul[us]\\.
+ * check-output-excludes: divs\\.
+ * check-output-contains: neg\\.
+ * check-output-contains: divu\\.
+ * check-output-pattern-3-times: neg\\.
+ */
